MethodTree (Java SE 10 & JDK 10 )
Keywords: com.sun.source.tree.MethodTree interface

Module jdk.compiler
Package com.sun.source.tree

## Interface MethodTree

- All Superinterfaces:
    `Tree`

      public interface MethodTree
      extends Tree

  A tree node for a method or annotation type element declaration. For example:

         modifiers typeParameters type name
            ( parameters )
            body

         modifiers type name () default defaultValue

  Since:
    1.6
  See The Java™ Language Specification:
    sections 8.4, 8.6, 8.7, 9.4, and 9.6

- - ### Nested Class Summary

    - ### Nested classes/interfaces declared in interface com.sun.source.tree.Tree

      `Tree.Kind`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `BlockTree` | `getBody()` | Returns the method body, or `null` if this is an abstract or native method.
    `Tree` | `getDefaultValue()` | Returns the default value, if this is an element within an annotation type declaration.
    `ModifiersTree` | `getModifiers()` | Returns the modifiers, including any annotations for the method being declared.
    `Name` | `getName()` | Returns the name of the method being declared.
    `List<? extends VariableTree>` | `getParameters()` | Returns the parameters of the method being declared.
    `VariableTree` | `getReceiverParameter()` | Return an explicit receiver parameter ("this" parameter), or `null` if none.
    `Tree` | `getReturnType()` | Returns the return type of the method being declared.
    `List<? extends ExpressionTree>` | `getThrows()` | Returns the exceptions listed as being thrown by this method.
    `List<? extends TypeParameterTree>` | `getTypeParameters()` | Returns the type parameters of the method being declared.

    - ### Methods declared in interface com.sun.source.tree.Tree

      `accept, getKind`

- - ### Method Detail

    - #### getModifiers

          ModifiersTree getModifiers()

      Returns the modifiers, including any annotations for the method being declared.
      Returns:
        the modifiers

    - #### getName

          Name getName()

      Returns the name of the method being declared.
      Returns:
        the name

    - #### getReturnType

          Tree getReturnType()

      Returns the return type of the method being declared. Returns `null` for a constructor.
      Returns:
        the return type

    - #### getTypeParameters

          List<? extends TypeParameterTree> getTypeParameters()

      Returns the type parameters of the method being declared.
      Returns:
        the type parameters

    - #### getParameters

          List<? extends VariableTree> getParameters()

      Returns the parameters of the method being declared.
      Returns:
        the parameters

    - #### getReceiverParameter

          VariableTree getReceiverParameter()

      Return an explicit receiver parameter ("this" parameter), or `null` if none.
      Returns:
        an explicit receiver parameter ("this" parameter)
      Since:
        1.8

    - #### getThrows

          List<? extends ExpressionTree> getThrows()

      Returns the exceptions listed as being thrown by this method.
      Returns:
        the exceptions

    - #### getBody

          BlockTree getBody()

      Returns the method body, or `null` if this is an abstract or native method.
      Returns:
        the method body

    - #### getDefaultValue

          Tree getDefaultValue()

      Returns the default value, if this is an element within an annotation type declaration. Returns `null` otherwise.
      Returns:
        the default value